// Hello World with OpenGL compute shader!
// I have wanted to do this for a long time and now it is done!
// This is slightly less elegant than its siblings since compute shaders
// can not deal with bytes. I chose to repackage to int on the CPU.
// This is an example, use freely.
// By Ingemar Ragnemalm 2017-2024

// Like my similar demos, if it outputs "Hello World!" then it works correctly.
// If it fails, it will most likely output "Hello Hello"

// Compile like this:

// g++ -o hello hello-cs.cpp Linux/MicroGlut.c CSutilities.c -I Linux/ -DGL_GLEXT_PROTOTYPES -lm -lGL -lX11

// Simplest version by using the CSutilities

#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h>
#include <GL/gl.h>
#include "MicroGlut.h"
#include "CSutilities.h"

int main(int argc, char **argv)
{
// Let GLUT create a GL context
	glutInit (&argc, argv);
	glutInitContextVersion(4, 5);
	glutCreateWindow("Hello");

// Uncomment to get extra info  
//	printf ("Vendor: %s\n", glGetString (GL_VENDOR));
//	printf ("Renderer: %s\n", glGetString (GL_RENDERER));
//	printf ("Version: %s\n", glGetString (GL_VERSION));
//	printf ("GLSL: %s\n", glGetString(GL_SHADING_LANGUAGE_VERSION));

// Load and compile the compute shader    
    GLuint p =loadComputeShader("hello.cs");

	GLuint ssbo, ssbo2; //Shader Storage Buffer Object

	// Some data
#define N 16
	char a[N] = "Hello \0\0\0\0\0\0";
	int ac[N];
	int b[N] = {15, 10, 6, 0, -11, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	int *ptr;
	int i;

	printf("%s", a);

// PROBLEM: No bytes in shaders!
// I chose to package to int on the CPU.
// Convert string to int:

	for (i = 0; i < N; i++) ac[i]=a[i];

// Create buffer, upload data
	glGenBuffers(1, &ssbo);
	glBindBuffer(GL_SHADER_STORAGE_BUFFER, ssbo);
	glBufferData(GL_SHADER_STORAGE_BUFFER, 16 * sizeof(int), &ac, GL_STATIC_DRAW);
	
// Tell it where the input goes!
// The "5" matches a "layuot" number in the shader.
// (Can we ask the shader about the number? I must try that.)
	glBindBufferBase(GL_SHADER_STORAGE_BUFFER, 5, ssbo);

// Same for the other buffer, offsets, ID 6
	glGenBuffers(1, &ssbo2);
	glBindBuffer(GL_SHADER_STORAGE_BUFFER, ssbo2);
	glBufferData(GL_SHADER_STORAGE_BUFFER, 16 * sizeof(int), &b, GL_STATIC_DRAW);
	glBindBufferBase(GL_SHADER_STORAGE_BUFFER, 6, ssbo2);

// Get rolling!
    glDispatchCompute(1, 1, 1); //Work groups launch

// Get data back!
	glBindBuffer(GL_SHADER_STORAGE_BUFFER, ssbo);
	ptr = (int *)glMapBuffer(GL_SHADER_STORAGE_BUFFER, GL_READ_ONLY);
// Convert int to string:
	for (i=0; i < 16; i++)
	{
		a[i] = ptr[i];
	}

	printf("%s\n", a);
}

